﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace PublishAndRaise
{
    public class Contact
    {
        public event EventHandler<AddressChangedEventArgs> AddressChanged;

        private string address;

        protected virtual void OnAddressChanged(AddressChangedEventArgs e)
        {
            EventHandler<AddressChangedEventArgs> handler = AddressChanged;
            if (handler != null)
            {
                handler(this, e);
            }
        }

        public string Address
        {
            get { return this.address; }
            set
            {
                this.address = value;
                AddressChangedEventArgs args = new AddressChangedEventArgs(this.address);
                OnAddressChanged(args);
            }
        }
    }
}
