﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApplication1
{
   struct Celsius
   {
      public float Degrees;

      public Celsius(float temperature)
      {
         this.Degrees = temperature;
      }

      public override string ToString()
      {
         return this.ToString("C");
      }

      public string ToString(string format)
      {
         if (String.IsNullOrWhiteSpace(format))
         {
            format = "C";
         }

         format = format.ToUpperInvariant().Trim();

         switch (format)
         {
            case "C":
            case "c":
               return this.Degrees.ToString("N2") + " °C";

            case "F":
            case "f":
               return (this.Degrees * 9 / 5 + 32).ToString("N2") + " °F";

            case "K":
            case "k":
               return (this.Degrees + 273.15f).ToString("N2") + " °K";

            default:
               throw new FormatException();
         }
      }
   }
}
