﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using PhotoViewer.Exif;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.Storage.BulkAccess;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace PhotoViewerMetro
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
           PopulatePicturesGrid();
        }

        private void PopulatePicturesGrid()
        {
           var folder = Windows.Storage.KnownFolders.PicturesLibrary;
           var queryOptions = new Windows.Storage.Search.QueryOptions()
           {
              FolderDepth = Windows.Storage.Search.FolderDepth.Deep,
              IndexerOption = Windows.Storage.Search.IndexerOption.UseIndexerWhenAvailable
           };

           var fileQuery = folder.CreateFileQueryWithOptions(queryOptions);

           var fif = new Windows.Storage.BulkAccess.FileInformationFactory(
              fileQuery,
              Windows.Storage.FileProperties.ThumbnailMode.PicturesView,
              190,
              Windows.Storage.FileProperties.ThumbnailOptions.UseCurrentScale,
              false
              );

           this.itemsViewSource.Source = fif.GetVirtualizedFilesVector();
        }

        private async void itemGridView_Tapped(object sender, TappedRoutedEventArgs e)
        {
           var item = e.OriginalSource as Image;
           if (item != null)
           {
              var fileInformation = item.DataContext as FileInformation;
              if (fileInformation != null)
              {
                 var photo = await ExifMetadata.Create(fileInformation);
                 this.metadataPanel.DataContext = photo;
              }
           }
        }
    }
}
