﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Web;

namespace PhotoViewerWeb
{
   /// <summary>
   /// Summary description for Thumbnail
   /// </summary>
   public class Thumbnail : IHttpHandler
   {

      public void ProcessRequest(HttpContext context)
      {
         context.Response.ContentType = "text/jpg";

         string imagePath = context.Request.MapPath(context.Request["path"]);

         if (File.Exists(imagePath))
         {
            using (Image source = Image.FromFile(imagePath))
            {
               float scale = 150.0f / System.Math.Max(source.Height, source.Width);
               using (Image thumbnail = source.GetThumbnailImage((int)(source.Width * scale), (int)(source.Height * scale), null, System.IntPtr.Zero))
               {
                  thumbnail.Save(context.Response.OutputStream, System.Drawing.Imaging.ImageFormat.Jpeg);
               }
            }
         }
      }

      public bool IsReusable
      {
         get
         {
            return true;
         }
      }
   }
}